#===============================================================
# NOTE: The figures are generated with the following environment:
# - On workstation
# Also: module load Phantomjs
#===============================================================

data <- array(rnorm(1000), dim = c('sdate' = 12, 'metric' = 4, 'region' = 3, 
                                   'time' = 6)) 
row.names <- c('Tropics', 'Extra-tropical NH', 'Extra-tropical SH')
col.names <- c('Mean bias (K)', 'Correlation', 'RPSS','CRPSS')

#--------------------------------------------------------------------
test_that("1. Test input", {
  # Check data
  expect_error(
    VizScorecard('a'),
    "Parameter 'data' must be a numeric array."
  )
  # Check row.dim
  expect_error(
    VizScorecard(data, row.dim = 1),
    "Parameter 'row.dim' must be a character string."
  )
  expect_error(
    VizScorecard(data, row.dim = 'a'),
    "Parameter 'row.dim' is not found in 'data' dimensions."
  )
  # Check row.names
  expect_error(
    VizScorecard(data, row.names = 'a'),
    paste0("Parameter 'row.names' must have the same length of dimension ",
           "'row.dims'.")
  )
})


#-------------------------------------------------------------------
# NOTE: A change is detected by expect_snapshot_file but I haven't found the difference

# # Simple example
# # Example with random data
# set.seed(1)
# data <- array(rnorm(1000), dim = c('sdate' = 12, 'metric' = 4, 'region' = 3, 
#                                    'time' = 6)) 
# row.names <- c('Tropics', 'Extra-tropical NH', 'Extra-tropical SH')
# col.names <- c('Mean bias (K)', 'Correlation', 'RPSS','CRPSS')

# save_fun <- function(...) {
#   path <- tempfile(fileext = ".png")
#   do.call(VizScorecard, list(..., fileout = path))
#   path
# }

# test_that("2. Output", {
#   expect_snapshot_file(
#     save_fun(data = data, row.names = row.names, col.names = col.names, 
#              subcol.names =  month.abb[as.numeric(1:12)],
#              row.title = 'Region', subrow.title = 'Forecast Month', 
#              col.title = 'Start date', 
#              table.title = "Temperature of ECMWF System 5", 
#              table.subtitle = "(Ref: ERA5 1994-2016)",
#              plot.legend = TRUE),
#     name = 'VizScorecard_1a.png' 
#   )
# })